#ifndef NETWORKDIALOGEDIT_H
#define NETWORKDIALOGEDIT_H

#include <QDialog>

namespace Ui {
    class NetWorkDialogEdit;
}
class QStandardItemModel;
class QModelIndex;
class QItemSelectionModel;
class QSettings;
class QMaemo5ValueButton;
class QStringList;
class QModelIndex;
class QListView;
class QMaemo5ListPickSelector;

/** \class NetWorkDialogEdit
  \brief class for dialog to edit rules
 */
class NetWorkDialogEdit : public QDialog {
    Q_OBJECT
public:
    NetWorkDialogEdit(QWidget *parent = 0);
    ~NetWorkDialogEdit();

    void SetProfilenames(QStringList list_of_profiles_nf);
    void SetNameOfLabel(QString id, QString name );
    QString GetNameProfile();
    QString GetNameOfRule();
    void SetNameOfRule(QString name);

protected:
    void changeEvent(QEvent *e);
    void accept();

private:
    Ui::NetWorkDialogEdit *ui;

    QMaemo5ValueButton *p_set_Profile_button;
    QMaemo5ListPickSelector *p_list_pick_profile;
    QStandardItemModel *p_model_profile_names;

    QString selectedProfile;
    QStringList list_of_profiles;

    QString name_of_rule;


private slots:
    void SelectedName(QString name);
};

#endif // NETWORKDIALOGEDIT_H
