#ifndef RULESMANAGER_H
#define RULESMANAGER_H

#include <QObject>
#include <QtCore/QFile>
#include <QtXml/QDomDocument>
#include <QtCore/QStringList>
#include <QtCore/QDir>
class QStandardItemModel;
class RulesManager : public QObject
{
    Q_OBJECT
public:
    explicit RulesManager(QObject *parent = 0);
        bool Init();

        QStandardItemModel * GetCellIDModel();
        QStandardItemModel * GetWiFiModel();
        QStandardItemModel * GetTelNumModel();

void SaveProfilesToXml();

signals:

public slots:
        void deleteProfilesNamesFromModels(QString profile_name);
private:
        bool InitFile();
        bool CreateFile();
        bool ReadFile();


        QFile fileIDWifiNum;
        QDomDocument domDocumentIDWifiTelnum;
        bool InitWIFIIDModels();
        bool CreatefileIDWifiNum();
        bool ReadfileIDWifiNum();
        QString CreateXmlTextIDWifi();
        bool CheckDomDocIDWifi();
        void initIDWIFTeleDoc();


        QStandardItemModel *model_of_CellID;
        QStandardItemModel *model_of_WiFi;
        QStandardItemModel *model_of_telephone_num;

        void UpdateWifiXml();
        void UpdateIDLocXml();
        void UpdateTelNumXml();
        QDomElement CreateNewIDEle(QString name, QStandardItemModel * model);
        void CreateNodeID(QDomElement * , QString , QString );


        void  LoadModelsWIFIIDTele();

};

#endif // RULESMANAGER_H
